#!/bin/false
# -*- coding: utf-8 -*-
"""
    Svem jabber bot
    Copyright (C) 2007 Sergey Melnikov

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/gpl-3.0.html>.
"""

import sys,xmpp,os,signal,time,random,urllib,re,codecs,string
import ConfigParser,feedparser,logging,logging.handlers

log = logging.getLogger("")

from ConfigManager import *
from PermitionManager import *


class AdminPlugin:
    conf = None
    permitions = None
    
    def __init__(self,conf, permitions):
        self.conf = conf
        self.permitions = permitions

    def help(self):
        return "    msg admin - отправить сообщение админу\n"
    
    def processMessage(self,conn,text,who):
        if (text.lower().find("addadv")==0):
            if (not self.permitions.isAdmin(who)):
                return False
            jid = text[text.find(" ")+1:]
            self.conf.advanced+=[jid]
            self.conf.writeConfig()
            return True
        if (text.lower().find("addban")==0):
            if (not self.permitions.isAdmin(who)):
                return False
            jid = text[text.find(" ")+1:]
            self.conf.banned+=[jid]
            self.conf.writeConfig()
            return True
        if (text.lower().find("lsadv")==0):
            if (not self.permitions.isAdmin(who)):
                return False
            conn.send(xmpp.protocol.Message(who,str(self.conf.advanced),"chat"))
            return True
        if (text.lower().find("msg")==0):
            text = text[4:]
            to = text[:text.find(" ")]
            msg = text[text.find(" ")+1:]
            if (self.permitions.isAdmin(who)):
                log.info("message to +"+to+" "+msg)
                conn.send(xmpp.protocol.Message(to,msg,"chat"))
                return True
            elif (to=="admin"):
                to = self.conf.admins[0]
                log.info("msg admin to "+to)
                conn.send(xmpp.protocol.Message(to,u"Сообщение от "+unicode(who)+" : "+msg,"chat"))
                return True
            else:
                conn.send(xmpp.protocol.Message(who,u"Вы не админ, используйте \"msg admin сообщение\", чтобы отправить сообщение админу","chat"))
                return True
        if (text.lower().find("ssh")==0):
            if (not self.permitions.isAdmin(who)):
                return False
            """
            Это потенциально может уронить бота
            """
            text = text[4:]
            cmd = text[:text.find("#")]
            stdin = text[text.find("#")+1:]
            if (text.find("#")==-1):
                cmd = text
                stdin = ""
            log.info("try "+cmd+" with "+stdin+" by "+unicode(who))
            f=codecs.open("./svembot_ssh_task", "wb","utf-8")
            f.write(stdin+"\n")
            f.close()
            pr= cmd+" <./svembot_ssh_task 2>&1 > ./svembot_ssh_output"
            os.system(pr)
            time.sleep(1)
            f=codecs.open("./svembot_ssh_output", "rb","utf-8")
            msg = f.read()
            f.close()
            conn.send(xmpp.protocol.Message(who,msg,"chat"))
            log.info("run "+cmd+" ok")
            return True
        return False
