#!/bin/false
# -*- coding: utf-8 -*-
"""
    Svem jabber bot
    Copyright (C) 2007 Sergey Melnikov

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/gpl-3.0.html>.
"""

import sys,xmpp,os,signal,time,random,urllib,re,codecs,string
import ConfigParser,feedparser,logging,logging.handlers

log = logging.getLogger("")

from ConfigManager import *
from PermitionManager import *

class StatisticsPlugin:
    start = 0
    count = 0
    users = {}
    command = {}
    conf = None
    permitions = None
    
    def __init__(self,conf, permitions):
        self.conf = conf
        self.permitions = permitions
        self.start = time.time()

    def help(self):
        return "    stat - статистика бота\n"

    def processMessage(self,conn,text,who):
        sender = (who.getNode()+"@"+who.getDomain())
        try:
            self.users[sender] += 1
        except KeyError , ke:
            self.users[sender] = 1
        try:
            self.command[text] += 1
        except KeyError , ke:
            self.command[text] = 1
        
        #log.debug(sender+" : "+str(self.users[sender])+"\n")

        if (text.lower().find("stat")==0):
            #if (not self.permitions.isAdvanced(who)):
            #    return False
            stat = u"Я работаю с "+time.ctime(self.start)+"\n";
            stat += u"=== Статистика запросов ===\n";
            for i in self.users.keys():
                stat += i+" : "+str(self.users[i])+"\n"
            if (self.permitions.isAdmin(who)):
                stat+="=========\n"
                for i in self.command.keys():
                    stat += i+" : "+str(self.command[i])+"\n"
            conn.send(xmpp.protocol.Message(who,stat,"chat"))
            return True
        return False
