import sys,xmpp,os,signal,time,random,urllib,re,codecs,string
import ConfigParser,feedparser,logging,logging.handlers

log = logging.getLogger("")


class ConfigManager:
    config_filename = "bot.conf"    
    
    #Permitions
    admins = ["admin@localhost"]
    advanced = ["admin@localhost"]
    banned = ["spamer@localhost"]
    
    # General
    jid_str = "bot@localhost"
    password = "1234"
    resource = "bot"
    config = None
    keepalive_delay = 1000
    timer = 1000

    # Plugins
    plugins = [] 
    plugins_with_timer = []


    
    def readConfig(self):
        self.config = ConfigParser.ConfigParser()
        self.config.read(self.config_filename)
        self.plugins = self.config.get("General","plugins").split(",")
        self.plugins_with_timer = self.config.get("General","plugins_with_timer").split(",")
        self.jid_str  = self.config.get("General","jid")
        self.resource = self.config.get("General","res")
        self.password = self.config.get("General","password")
        self.keepalive_delay = int(self.config.get("General","keepalive_delay"))
        self.timer= int(self.config.get("General","timer"))
        self.admins = self.config.get("Permitions","admins").split(",")
        log.debug(self.admins)
        self.advanced = self.config.get("Permitions","advanced").split(",")
        log.debug(self.banned)
        self.banned = self.config.get("Permitions","banned").split(",")
        log.debug(self.advanced)
    
    def get(self,section,key):
        return self.config.get(section,key)
    
    def writeConfig(self):
        self.config.set("General","jid",self.jid_str)
        self.config.set("General","res",self.resource)
        self.config.set("General","password",self.password)
        self.config.set("General","keepalive_delay",str(self.keepalive_delay))
        self.config.set("General","timer",str(self.timer))
        admins_str = ""
        for a in self.admins:
            if (a!=""):
                admins_str+=a+","
        self.config.set("Permitions","admins",admins_str)
        advanced_str = ""
        for a in self.advanced:
            if (a!=""):
                advanced_str+=a+","
        self.config.set("Permitions","advanced",advanced_str)
        banned_str = ""
        for a in self.banned:
            if (a!=""):
                banned_str+=a+","
        self.config.set("Permitions","banned",banned_str)
        f=open(self.config_filename, "wb")
        self.config.write(f)
        f.close()
        
class PersonalConfig:
    filename = ""
    conf = None
    def _init__(self,filename):
        self.filename = filename
        self.config = ConfigParser.ConfigParser()
        self.config.read(self.filename)        
        
    def get(self,parameter):
        return self.config.get("General",parameter)

    def set(self,parameter,value):    
        self.config.set("General",parameter,value)
        f=open(self.filename,"wb")
        self.config.write(f)
        f.close()