#!/bin/false
# -*- coding: utf-8 -*-
"""
    Svem jabber bot
    Copyright (C) 2007 Sergey Melnikov

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/gpl-3.0.html>.
"""

import sys,xmpp,os,signal,time,random,urllib,re,codecs,string
import ConfigParser,feedparser,logging,logging.handlers

log = logging.getLogger("")

from ConfigManager import *
from PermitionManager import *

class Bugzilla:
    conf = None
    permitions = None
    
    def __init__(self,conf, permitions):
        self.conf = conf
        self.permitions = permitions
    
    
    def help(self):
        return "    bug <описание бага> - сообщить о баге\n    listbugs - вывести список известных недостатков\n"
    def processMessage(self,conn,text,who):
        if (text.lower().find("listbugs")==0):
            f=codecs.open("bugs", "rb","utf-8")
            msg = f.read()
            f.close()
            conn.send(xmpp.protocol.Message(who,u"""Список известных недостатков:\n"""+msg,"chat"))
            return True
        if (text.lower().find("bug")==0):
            try:
                f=codecs.open("./bugs", "ab","utf-8")
            except IOError:
                conn.send(xmpp.protocol.Message(who,"Файл с программой называтется не bot.py, напишете админу","chat"))
                return True
            f.write(unicode(who)+": "+text+"\n\n")
            f.close()
            log.info("bug from "+unicode(who)+" : "+unicode(text))
            conn.send(xmpp.protocol.Message(who,"Ваш баг зарегистрирован, надейтесь на скорое исправление","chat"))
            return True
        return False
